# ]po[ Finance Core
This package is part of ]project-open[, an open-source enterprise project management system.

For more information about ]project-open[ please see:
* [Documentation Wiki](https://www.project-open.com/en/)
* [V5.0 Download](https://sourceforge.net/projects/project-open/files/project-open/V5.0/)
* [Installation Instructions](https://www.project-open.com/en/list-installers)

About ]po[ Finance Core:

<p><p>This package is the base platform for cost management operations and defines cost centers, cost items and investments. All billing, invoicing, and quotes are associated by and managed through the Finance Core. <p><p><img alt="" src="https://www.project-open.com/images/manual_screenshots/screenshot_finance_core_2.gif" /><p> (Screenshot listing all &quot;Customer&quot; related documents currently on the system. Presented by order of Due Date by default. To resort the listing click on the appropriate column header.) <p><img alt="" src="https://www.project-open.com/images/manual_screenshots/screenshot_finance_core_1.gif" /><p>(Screenshot displaying all &quot;Outstanding&quot; invoices belonging to &quot;Customer&quot; between the specified dates.) <p><p><strong>Financial Document Display Filters</strong><p><p>To selectively view documents, use the filters to screen all the available documents using the parameters below, one per field. <ul><li>Document Status - All, Created, Deleted, Filed, Outstanding, Paid, Past Due, Partially Paid, Rejected, Requested<li>Document Type - &shy;All, Employee Salary, Repeating Cost, Timesheet Cost, Expense Item, Expense Bundle, Timesheet Budget, Expense Planned Cost<ul type="circle"><li>&shy;Customer Documents &shy;- Customer Invoice, Quote, Delivery Note<li>Provider Do&shy;cuments - Provider Bill, Purchase Order</ul><li>Company - All available and registered companies on the system<li>Start Date<li>End Date&shy; </ul><p>All financial documents relating to &quot;Providers&quot; are formatted and searchable in the exact same manner as those belonging to Customers. To navigate to a view of Provider financial documents, simply click on the &quot;Providers&quot; header located to the right of &quot;Customer&quot;. <a name="finance_summary"> </a><ul></ul>

# Online Reference Documentation

## Procedure Files

<table cellpadding="0" cellspacing="0"><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=533&amp;path=packages/intranet-cost/lib/company-profit-loss.adp">lib/company-profit-loss.adp</a></b></td><td></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=533&amp;path=packages/intranet-cost/lib/company-profit-loss.tcl">lib/company-profit-loss.tcl</a></b></td><td></td><td>company-profit-loss.tcl </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/procs-file-view?version_id=533&amp;path=packages/intranet-cost/tcl/intranet-cost-center-procs.tcl">tcl/intranet-cost-center-procs.tcl</a></b></td><td></td><td>Cost Centers </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/procs-file-view?version_id=533&amp;path=packages/intranet-cost/tcl/intranet-cost-procs.tcl">tcl/intranet-cost-procs.tcl</a></b></td><td></td><td>Bring together all &quot;components&quot; (=HTML + SQL code) related to Costs </td></tr></table>

## Procedures

<table cellpadding="0" cellspacing="0"><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=533&amp;proc=im_cc_read_p">im_cc_read_p</a></b></td><td></td><td>Returns &quot;1&quot; if the user can read the global &quot;company&quot; CC </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=533&amp;proc=im_company_payment_balance_component">im_company_payment_balance_component</a></b></td><td></td><td>Returns a formatted HTML with invoices vs. </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=533&amp;proc=im_cost::new">im_cost::new</a></b></td><td></td><td>Create a new cost item and return its ID. </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=533&amp;proc=im_cost_cache_sweeper">im_cost_cache_sweeper</a></b></td><td></td><td>Checks for the MaxCount projects with the &quot;oldest&quot; outdated cost caches. </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=533&amp;proc=im_cost_center_company">im_cost_center_company</a></b></td><td></td><td>Returns the ID of the &quot;Company - Co&quot; Cost Center </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=533&amp;proc=im_cost_center_name">im_cost_center_name</a></b></td><td></td><td>Returns the cached name of a cost center </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=533&amp;proc=im_cost_center_options">im_cost_center_options</a></b></td><td></td><td>Returns a list of all Cost Centers in the company. </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=533&amp;proc=im_cost_center_permissions">im_cost_center_permissions</a></b></td><td></td><td>Fill the &quot;by-reference&quot; variables read, write and admin with the permissions of $user_id on $cost_center_id.&lt;br&gt; </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=533&amp;proc=im_cost_center_read_p">im_cost_center_read_p</a></b></td><td></td><td>Returns &quot;1&quot; if the user can read the CC, &quot;0&quot; otherwise. </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=533&amp;proc=im_cost_center_select">im_cost_center_select</a></b></td><td></td><td>Returns a select box with all Cost Centers in the company. </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=533&amp;proc=im_cost_center_status_active">im_cost_center_status_active</a></b></td><td></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=533&amp;proc=im_cost_center_status_inactive">im_cost_center_status_inactive</a></b></td><td></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=533&amp;proc=im_cost_center_status_options">im_cost_center_status_options</a></b></td><td></td><td>Cost Center status options </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=533&amp;proc=im_cost_center_type_cost_center">im_cost_center_type_cost_center</a></b></td><td></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=533&amp;proc=im_cost_center_type_investment_center">im_cost_center_type_investment_center</a></b></td><td></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=533&amp;proc=im_cost_center_type_options">im_cost_center_type_options</a></b></td><td></td><td>Cost Center type options </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=533&amp;proc=im_cost_center_type_profit_center">im_cost_center_type_profit_center</a></b></td><td></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=533&amp;proc=im_cost_center_type_subdepartment">im_cost_center_type_subdepartment</a></b></td><td></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=533&amp;proc=im_cost_center_write_p">im_cost_center_write_p</a></b></td><td></td><td>Returns &quot;1&quot; if the user can write to the CC, &quot;0&quot; otherwise. </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=533&amp;proc=im_cost_center_write_p_helper">im_cost_center_write_p_helper</a></b></td><td></td><td>Returns &quot;t&quot; if the user can write to the CC, &quot;f&quot; otherwise. </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=533&amp;proc=im_cost_financial_document_type_ids">im_cost_financial_document_type_ids</a></b></td><td></td><td>Returns an TCL list of all cost_type_ids of financial documents. </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=533&amp;proc=im_cost_payment_method_select">im_cost_payment_method_select</a></b></td><td></td><td>Returns an html select box named $select_name and defaulted to $default with a list of all the partner statuses in the system </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=533&amp;proc=im_cost_permissions">im_cost_permissions</a></b></td><td></td><td>Fill the &quot;by-reference&quot; variables read, write and admin with the permissions of $user_id on $cost_id.&lt;br&gt; Cost permissions depend on the rights of the underlying company and on Cost Center permissions. </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=533&amp;proc=im_cost_project_document_icons">im_cost_project_document_icons</a></b></td><td></td><td>Shows a list of icons for each financial document available as part of the project. </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=533&amp;proc=im_cost_project_document_icons_helper">im_cost_project_document_icons_helper</a></b></td><td></td><td>Helper for: Shows a list of icons for each financial document available as part of the project. </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=533&amp;proc=im_cost_status_created">im_cost_status_created</a></b></td><td></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=533&amp;proc=im_cost_status_deleted">im_cost_status_deleted</a></b></td><td></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=533&amp;proc=im_cost_status_filed">im_cost_status_filed</a></b></td><td></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=533&amp;proc=im_cost_status_options">im_cost_status_options</a></b></td><td></td><td>Cost status options </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=533&amp;proc=im_cost_status_outstanding">im_cost_status_outstanding</a></b></td><td></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=533&amp;proc=im_cost_status_paid">im_cost_status_paid</a></b></td><td></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=533&amp;proc=im_cost_status_partially_paid">im_cost_status_partially_paid</a></b></td><td></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=533&amp;proc=im_cost_status_past_due">im_cost_status_past_due</a></b></td><td></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=533&amp;proc=im_cost_status_rejected">im_cost_status_rejected</a></b></td><td></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=533&amp;proc=im_cost_status_requested">im_cost_status_requested</a></b></td><td></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=533&amp;proc=im_cost_status_select">im_cost_status_select</a></b></td><td></td><td>Returns an html select box named $select_name and defaulted to $default with a list of all the cost status_types in the system </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=533&amp;proc=im_cost_template_options">im_cost_template_options</a></b></td><td></td><td>Cost Template options </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=533&amp;proc=im_cost_template_select">im_cost_template_select</a></b></td><td></td><td>Returns an html select box named $select_name and defaulted to $default with a list of all the partner statuses in the system </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=533&amp;proc=im_cost_type_bill">im_cost_type_bill</a></b></td><td></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=533&amp;proc=im_cost_type_company_doc">im_cost_type_company_doc</a></b></td><td></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=533&amp;proc=im_cost_type_customer_doc">im_cost_type_customer_doc</a></b></td><td></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=533&amp;proc=im_cost_type_delivery_note">im_cost_type_delivery_note</a></b></td><td></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=533&amp;proc=im_cost_type_employee">im_cost_type_employee</a></b></td><td></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=533&amp;proc=im_cost_type_expense_bundle">im_cost_type_expense_bundle</a></b></td><td></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=533&amp;proc=im_cost_type_expense_item">im_cost_type_expense_item</a></b></td><td></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=533&amp;proc=im_cost_type_expense_planned">im_cost_type_expense_planned</a></b></td><td></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=533&amp;proc=im_cost_type_interco_invoice">im_cost_type_interco_invoice</a></b></td><td></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=533&amp;proc=im_cost_type_interco_quote">im_cost_type_interco_quote</a></b></td><td></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=533&amp;proc=im_cost_type_invoice">im_cost_type_invoice</a></b></td><td></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=533&amp;proc=im_cost_type_is_invoice_or_bill_p">im_cost_type_is_invoice_or_bill_p</a></b></td><td></td><td>Invoices and Bills have a &quot;Payment Terms&quot; field. </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=533&amp;proc=im_cost_type_is_invoice_or_quote_p">im_cost_type_is_invoice_or_quote_p</a></b></td><td></td><td>Invoices and Quotes have a &quot;Company&quot; fields, so we need to identify them: </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=533&amp;proc=im_cost_type_options">im_cost_type_options</a></b></td><td></td><td>Cost type options </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=533&amp;proc=im_cost_type_order">im_cost_type_order</a></b></td><td></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=533&amp;proc=im_cost_type_planned_purchase">im_cost_type_planned_purchase</a></b></td><td></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=533&amp;proc=im_cost_type_po">im_cost_type_po</a></b></td><td></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=533&amp;proc=im_cost_type_provider_doc">im_cost_type_provider_doc</a></b></td><td></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=533&amp;proc=im_cost_type_provider_receipt">im_cost_type_provider_receipt</a></b></td><td></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=533&amp;proc=im_cost_type_provider_travel">im_cost_type_provider_travel</a></b></td><td></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=533&amp;proc=im_cost_type_quote">im_cost_type_quote</a></b></td><td></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=533&amp;proc=im_cost_type_repeating">im_cost_type_repeating</a></b></td><td></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=533&amp;proc=im_cost_type_select">im_cost_type_select</a></b></td><td></td><td>Returns an html select box named $select_name and defaulted to $default with a list of all the cost_types in the system. </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=533&amp;proc=im_cost_type_short_name">im_cost_type_short_name</a></b></td><td></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=533&amp;proc=im_cost_type_timesheet">im_cost_type_timesheet</a></b></td><td></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=533&amp;proc=im_cost_type_timesheet_budget">im_cost_type_timesheet_budget</a></b></td><td></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=533&amp;proc=im_cost_type_timesheet_hours">im_cost_type_timesheet_hours</a></b></td><td></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=533&amp;proc=im_cost_type_write_p">im_cost_type_write_p</a></b></td><td></td><td>Returns &quot;1&quot; if the user can create costs of type cost_type_id or 0 otherwise </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=533&amp;proc=im_cost_type_write_permissions">im_cost_type_write_permissions</a></b></td><td></td><td>Returns a list of all cost_type_ids for which the user has write permissions for atleast one Cost Center. </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=533&amp;proc=im_cost_type_write_permissions_helper">im_cost_type_write_permissions_helper</a></b></td><td></td><td>Returns a list of all cost_type_ids for which the user has write permissions for atleast one Cost Center. </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=533&amp;proc=im_cost_uom_options">im_cost_uom_options</a></b></td><td></td><td>Cost UoM (Unit of Measure) options </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=533&amp;proc=im_cost_update_payments">im_cost_update_payments</a></b></td><td></td><td>Update the payment amount for a cost item by summing up all payments for this item. </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=533&amp;proc=im_cost_update_project_cost_cache">im_cost_update_project_cost_cache</a></b></td><td></td><td>Calculates the sums of all cost elements per project, including subprojects of arbitrary depth. </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=533&amp;proc=im_costs_base_component">im_costs_base_component</a></b></td><td></td><td>Returns a HTML table containing a list of costs for a particular company or project. </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=533&amp;proc=im_costs_company_component">im_costs_company_component</a></b></td><td></td><td>Returns a HTML table containing a list of costs for a particular company. </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=533&amp;proc=im_costs_company_profit_loss_component">im_costs_company_profit_loss_component</a></b></td><td></td><td>Returns a HTML component to show a list of all main projects together with profit &amp; loss per project. </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=533&amp;proc=im_costs_default_cost_center_for_user">im_costs_default_cost_center_for_user</a></b></td><td></td><td>Returns a reasonable default cost center for a given user. </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=533&amp;proc=im_costs_navbar">im_costs_navbar</a></b></td><td></td><td>Returns rendered HTML code for a horizontal sub-navigation bar for /intranet-cost/. </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=533&amp;proc=im_costs_object_list_component">im_costs_object_list_component</a></b></td><td></td><td>Returns a HTML table containing a list of objects associated with a particular financial document. </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=533&amp;proc=im_costs_project_component">im_costs_project_component</a></b></td><td></td><td>Returns a HTML table containing a list of costs for a particular project. </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=533&amp;proc=im_costs_project_finance_component">im_costs_project_finance_component</a></b></td><td></td><td>Returns a HTML table containing a detailed summary of all financial activities of the project. </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=533&amp;proc=im_costs_select">im_costs_select</a></b></td><td></td><td>Returns an html select box named $select_name and defaulted to $default with a list of all the costs in the system. </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=533&amp;proc=im_currency_options">im_currency_options</a></b></td><td></td><td>Cost currency options </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=533&amp;proc=im_currency_select">im_currency_select</a></b></td><td></td><td>Return a HTML widget that selects a currency code from the list of global countries. </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=533&amp;proc=im_default_currency">im_default_currency</a></b></td><td></td><td>Returns the default system currency </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=533&amp;proc=im_department_options">im_department_options</a></b></td><td></td><td>Returns a list of all Departments in the company. </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=533&amp;proc=im_investment_options">im_investment_options</a></b></td><td></td><td>Cost investment options </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=533&amp;proc=im_menu_finance_admin_links">im_menu_finance_admin_links</a></b></td><td></td><td>Return a list of admin links to be added to the &quot;absences&quot; menu </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=533&amp;proc=im_navbar_tree_finance">im_navbar_tree_finance</a></b></td><td></td><td>Finance Navbar </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=533&amp;proc=im_next_cost_nr">im_next_cost_nr</a></b></td><td></td><td>Returns the next free cost number Cost_nr&#39;s look like: 2003_07_123 with the first 4 digits being the current year, the next 2 digits the month and the last 3 digits as the current number within the month. </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=533&amp;proc=im_package_cost_id">im_package_cost_id</a></b></td><td></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=533&amp;proc=im_payment_method_cash">im_payment_method_cash</a></b></td><td></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=533&amp;proc=im_payment_method_undefined">im_payment_method_undefined</a></b></td><td></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=533&amp;proc=im_sub_cost_center_ids">im_sub_cost_center_ids</a></b></td><td></td><td>Returns the list of sub cost centers, order by tree_sortkey. </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=533&amp;proc=im_sub_cost_center_ids_helper">im_sub_cost_center_ids_helper</a></b></td><td></td><td>Returns the list of sub cost centers, order by tree_sortkey. </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=533&amp;proc=im_supported_currencies">im_supported_currencies</a></b></td><td></td><td>Returns the list of supported currencies </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=533&amp;proc=im_user_cost_centers">im_user_cost_centers</a></b></td><td></td><td>Returns the list of all cost-centes of the user including sub cost-centers </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=533&amp;proc=n20">n20</a></b></td><td></td><td>Converts null (&quot;&quot;) values to numeric &quot;0&quot;. </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=533&amp;proc=template::widget::im_cost_center_tree">template::widget::im_cost_center_tree</a></b></td><td></td><td>ad_form tree widget for cost centers and departments. </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=533&amp;proc=template::widget::im_currencies">template::widget::im_currencies</a></b></td><td></td><td>ad_form widget for active currencies The widget displays a list of active currencies. </td></tr></table>

## SQL Files

<table cellpadding="0" cellspacing="0"><tr valign="top"><td><b><a href="https://www.project-open.net/api-doc/display-sql?package_key=intranet-cost&amp;url=postgresql/intranet-cost-backup.sql&amp;version_id=533">sql/postgresql/intranet-cost-backup.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="https://www.project-open.net/api-doc/display-sql?package_key=intranet-cost&amp;url=postgresql/intranet-cost-center-create.sql&amp;version_id=533">sql/postgresql/intranet-cost-center-create.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="https://www.project-open.net/api-doc/display-sql?package_key=intranet-cost&amp;url=postgresql/intranet-cost-common.sql&amp;version_id=533">sql/postgresql/intranet-cost-common.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="https://www.project-open.net/api-doc/display-sql?package_key=intranet-cost&amp;url=postgresql/intranet-cost-components-create.sql&amp;version_id=533">sql/postgresql/intranet-cost-components-create.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="https://www.project-open.net/api-doc/display-sql?package_key=intranet-cost&amp;url=postgresql/intranet-cost-create.sql&amp;version_id=533">sql/postgresql/intranet-cost-create.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="https://www.project-open.net/api-doc/display-sql?package_key=intranet-cost&amp;url=postgresql/intranet-cost-drop.sql&amp;version_id=533">sql/postgresql/intranet-cost-drop.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="https://www.project-open.net/api-doc/display-sql?package_key=intranet-cost&amp;url=postgresql/intranet-cost-menus-create.sql&amp;version_id=533">sql/postgresql/intranet-cost-menus-create.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="https://www.project-open.net/api-doc/display-sql?package_key=intranet-cost&amp;url=postgresql/intranet-investment-create.sql&amp;version_id=533">sql/postgresql/intranet-investment-create.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="https://www.project-open.net/api-doc/display-sql?package_key=intranet-cost&amp;url=postgresql/intranet-price-list-create.sql&amp;version_id=533">sql/postgresql/intranet-price-list-create.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="https://www.project-open.net/api-doc/display-sql?package_key=intranet-cost&amp;url=postgresql/intranet-repeating-cost-create.sql&amp;version_id=533">sql/postgresql/intranet-repeating-cost-create.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="https://www.project-open.net/api-doc/display-sql?package_key=intranet-cost&amp;url=postgresql/upgrade/upgrade-5.0.2.2.0-5.0.2.2.1.sql&amp;version_id=533">sql/postgresql/upgrade/upgrade-5.0.2.2.0-5.0.2.2.1.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="https://www.project-open.net/api-doc/display-sql?package_key=intranet-cost&amp;url=postgresql/upgrade/upgrade-5.0.2.2.1-5.0.2.2.2.sql&amp;version_id=533">sql/postgresql/upgrade/upgrade-5.0.2.2.1-5.0.2.2.2.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="https://www.project-open.net/api-doc/display-sql?package_key=intranet-cost&amp;url=postgresql/upgrade/upgrade-5.0.2.3.0-5.0.2.3.1.sql&amp;version_id=533">sql/postgresql/upgrade/upgrade-5.0.2.3.0-5.0.2.3.1.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="https://www.project-open.net/api-doc/display-sql?package_key=intranet-cost&amp;url=postgresql/upgrade/upgrade-5.0.2.3.5-5.0.2.3.6.sql&amp;version_id=533">sql/postgresql/upgrade/upgrade-5.0.2.3.5-5.0.2.3.6.sql</a></b></td><td></td><td></td></tr></table>

## Content Pages

<table cellpadding="0" cellspacing="0"><tr valign="top"><td><b>www/</b></td></tr><tr valign="top"><td><b>cost-centers/</b></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=533&amp;path=packages/intranet-cost/www/cost-centers/cost-center-action.tcl">cost-center-action.tcl</a></b></td><td>Delete selected cost_centers</td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=533&amp;path=packages/intranet-cost/www/cost-centers/index.adp">index.adp</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=533&amp;path=packages/intranet-cost/www/cost-centers/index.tcl">index.tcl</a></b></td><td>Show the permissions for all cost_centers in the system</td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=533&amp;path=packages/intranet-cost/www/cost-centers/new.adp">new.adp</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=533&amp;path=packages/intranet-cost/www/cost-centers/new.tcl">new.tcl</a></b></td><td>Create a new dynamic value or edit an existing one.</td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=533&amp;path=packages/intranet-cost/www/cost-centers/permissions-user-add.adp">permissions-user-add.adp</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=533&amp;path=packages/intranet-cost/www/cost-centers/permissions-user-add.tcl">permissions-user-add.tcl</a></b></td><td>Redirect page for adding users to the permissions list.</td></tr><tr valign="top"><td><b>costs/</b></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=533&amp;path=packages/intranet-cost/www/costs/cost-action.tcl">cost-action.tcl</a></b></td><td>Purpose: Takes commands from the /intranet-cost/index page and deletes costs where marked</td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=533&amp;path=packages/intranet-cost/www/costs/new.adp">new.adp</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=533&amp;path=packages/intranet-cost/www/costs/new.tcl">new.tcl</a></b></td><td>Create a new dynamic value or edit an existing one.</td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=533&amp;path=packages/intranet-cost/www/index.adp">index.adp</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=533&amp;path=packages/intranet-cost/www/index.tcl">index.tcl</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=533&amp;path=packages/intranet-cost/www/list.adp">list.adp</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=533&amp;path=packages/intranet-cost/www/list.tcl">list.tcl</a></b></td><td>List all costs together with their payments</td></tr><tr valign="top"><td><b>rep-costs/</b></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=533&amp;path=packages/intranet-cost/www/rep-costs/index.adp">index.adp</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=533&amp;path=packages/intranet-cost/www/rep-costs/index.tcl">index.tcl</a></b></td><td>Shows a summary of the loged hours by all team members of a project (1 week)</td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=533&amp;path=packages/intranet-cost/www/rep-costs/new-rep-cost.adp">new-rep-cost.adp</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=533&amp;path=packages/intranet-cost/www/rep-costs/new-rep-cost.tcl">new-rep-cost.tcl</a></b></td><td>Create a new cost item from a repeating cost such as employee salaries, rent or other fixed costs</td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=533&amp;path=packages/intranet-cost/www/rep-costs/new.adp">new.adp</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=533&amp;path=packages/intranet-cost/www/rep-costs/new.tcl">new.tcl</a></b></td><td>Create a new dynamic value or edit an existing one.</td></tr></table>

